﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace ReplayFolderSelecter
{
    class CurrentReplayFolder
    {
        private string[] replays;

        private string nickname;

        public string[] Replays
        {
            get
            {
                return replays;
            }
        }

        public string Nickname
        {
            get
            {
                return nickname;
            }
            set
            {
                try
                {
                    Util.WriteNickname(Util.REPLAY_FOLDER, value);
                    nickname = value;
                }
                catch (IOException)
                {
                    MessageBox.Show("ニックネームの設定に失敗しました", "ERROR");
                }
            }
        }

        public void Update()
        {
            string[] dirs = Directory.GetDirectories(Util.REPLAY_FOLDER, "*");
            List<string> a = new List<string>();

            foreach (string d in dirs)
            {
                if (File.Exists(d + "\\_Header.ini"))
                {
                    a.Add(d.Substring(d.LastIndexOf('\\') + 1));
                }
            }

            replays = a.ToArray();
            nickname = Util.ReadNickname(Util.REPLAY_FOLDER);
        }

        public void RenameReplay(string oldname, string newname)
        {
            string dest = Util.REPLAY_FOLDER + "\\" + newname;

            try
            {
                if (Directory.Exists(dest))
                {
                    MessageBox.Show("リプレイ名が重複してしまいます！", "ERROR");
                }
                else
                {
                    Directory.Move(Util.REPLAY_FOLDER + "\\" + oldname, dest);
                }
            }
            catch (ArgumentException)
            {
                MessageBox.Show("ファイル名に使うことができない文字が含まれています", "ERROR");
            }
            catch (PathTooLongException)
            {
                MessageBox.Show("ファイル名が長すぎます", "ERROR");
            }
            catch (IOException)
            {
                MessageBox.Show("リプレイのリネームに失敗しました", "ERROR");
            }
        }

        public void RemoveReplay(string repname)
        {
            string msg = "本当に '" + repname + "' を削除しますか？";

            if (Util.YesNo(msg, "削除の確認"))
            {
                string path = Util.REPLAY_FOLDER + "\\" + repname;
                try
                {
                    Directory.Delete(path, true);
                }
                catch (IOException)
                {
                    MessageBox.Show(path + "の削除に失敗しました", "ERROR");
                }
            }
        }
    }
}
