﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace ReplayFolderSelecter
{
    public partial class HeaderDialog : Form
    {
        public static void ShowInstance(string repname)
        {
            string path = Util.REPLAY_FOLDER + "\\" + repname + "\\_Header.ini";
            try
            {
                string data = ReadHeader(path);
                HeaderDialog hd = new HeaderDialog(path, data);
                hd.ShowDialog();
            }
            catch (IOException)
            {
                MessageBox.Show("_Header.iniを読み込めません", "ERROR");
            }
        }

        private string path;

        private string data;

        public HeaderDialog(string _path, string _data)
        {
            InitializeComponent();
            path = _path;
            data = _data;
            userInput.Text = data;
        }

        private void cancelButton_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void OKButton_Click(object sender, EventArgs e)
        {
            try
            {
                if(CheckHeaderFile(path, data))
                {
                    WriteHeader(path, userInput.Text);
                    this.Close();
                }
            }
            catch (IOException)
            {
                MessageBox.Show("_Header.iniへのアクセスに失敗しました", "ERROR");
            }
        }

        #region sub

        private static string ReadHeader(string path)
        {
            StreamReader r = new StreamReader(path, System.Text.Encoding.Default);
            string data = r.ReadToEnd();
            r.Close();
            return data;
        }

        private static void WriteHeader(string path, string data)
        {
            string tmpname = Util.AvailableFileName(path + ".bak");
            File.Move(path, tmpname);

            try
            {
                StreamWriter w = new StreamWriter(path, false, System.Text.Encoding.Default);
                w.Write(data);
                w.Flush();
                w.Close();
                File.Delete(tmpname);
            }
            catch (IOException)
            {
                string msg = "保存に失敗しました。\n" + tmpname + "にバックアップファイルがあります";
                MessageBox.Show(msg, "ERROR");
            }
        }

        private static bool CheckHeaderFile(string path, string data)
        {
            if (data == ReadHeader(path))
            {
                return true;
            }

            string msg = "_Header.iniは他のアプリケーションから変更されています。\n本当に上書きしますか？";
            return Util.YesNo(msg, "上書きの確認");
        }

        #endregion
    }
}
